/*
 * FILE: mask_cb.c
 * 
 * ABSTRACT: Callback routines for the main window 
 * 
 * $Id: mask_cb.c,v 1.2 1998/12/30 19:07:21 rks Exp $
 * 
 * CHANGE LOG:
 * ##  who  ddMmmyy  defect  description
 * ==  ===  =======  ======  =================================================
 *  0  rks  28Jun98  -       initial
 */ 

#include <stdio.h>
#include <stdlib.h>

#include <forms.h>

#include "mask.h"
#include "config.h"
#include "globals.h"
#include "tools.h"
#include "callreg.h"

#include "dbgmem.h"


void cbCancel(FL_OBJECT *ob, long data)
{
    fl_finish();
    if(fulltext != NULL)
    {
        int i = 0;
        while(fulltext[i] != NULL)
        {
            Free(fulltext[i]);
            i++;
        }
        Free(fulltext);
    }
    DBG_MEM_EXIT();
    exit(0);
}

void cbList(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
    int i;

    i = fl_get_browser(ob);
    if(i == 0) return;
    if(i < 0)
    {
        printf("i < 0\n");
        i=-i;
    }

    fl_clear_browser(fd_main->Output);

    /* i - 1 because browser starts counting with 1 and C with 0 */
    fl_add_browser_line(fd_main->Output, fulltext[i-1]);

    return;
}

void TEST_IT_func()
{
    Window win = fl_winget();
    FILE    *fn;
    char     buffer[256];
    char     buf2[512];
    int      alltest;
    int      i;
    


    fn=fopen(TestFile, "rt");
    if(fn == NULL)
    {
        fprintf(stderr, "\nERROR: Xreg_TEST_FILE = \"%s\" not found\n\n",
                TestFile);
        exit(1);
    }
    
    alltest = 0;
    while(fgets(buffer, sizeof buffer, fn) != NULL)
    { 
        alltest++;
    }
    rewind(fn);

    
    i = 1;
    while(fgets(buffer, sizeof buffer, fn) != NULL)
    { 
        buffer[strlen(buffer) -1] = 0;
        sprintf(buf2, "Test %d of %d: \"%s\" ", i, alltest, buffer);

        fl_set_input(fd_main->SearchString, buf2);
        begin_work(win, "Searching...");
        init_browser(fd_main, buffer);
        end_work(win);
        i++;
    }
    fclose(fn);

    cbCancel(NULL, 0);
}

#define TEST_IT
void cbSearchString(FL_OBJECT *ob, long data)
{
    Window win = fl_winget();

    if(TestFile == NULL)
    {
        begin_work(win, "Searching...");
        init_browser(fd_main, (char *)fl_get_input(fd_main->SearchString));
        end_work(win);
    }
    else
    {
        TEST_IT_func();

    }
}

void cbSearch(FL_OBJECT *ob, long data)
{
    Window win = fl_winget();

    if(TestFile == NULL)
    {
        begin_work(win, "Searching...");
        init_browser(fd_main, (char *)fl_get_input(fd_main->SearchString));
        end_work(win);
    }
    else
    {
        TEST_IT_func();
    }


}

void cbUmlaut(FL_OBJECT *ob, long data)
{
    int         i;

    i = fl_get_choice(ob);

    switch(i)
    {
      case 1: 
        strcpy(ParamUmlaut, "-iso on");
        break;
      case 2:
        strcpy(ParamUmlaut, "-iso off");
        break;
      case 3:
        strcpy(ParamUmlaut, "-iso auto");
        break;
      default:
        printf("Unexpected input\n");
        break;
    }
}

void cbCase(FL_OBJECT *ob, long data)
{
    int         i;

    i = fl_get_choice(ob);

    switch(i)
    {
      case 1: 
        strcpy(ParamCase, "-ign off");
        break;
      case 2:
        strcpy(ParamCase, "-ign on");
        break;
      case 3:
        strcpy(ParamCase, "-ign auto");
        break;
      default:
        printf("Unexpected input\n");
        break;
    }
}

void cbRegEx(FL_OBJECT *ob, long data)
{
    int         i;

    i = fl_get_choice(ob);

    switch(i)
    {
      case 1: 
        strcpy(ParamRegEx, "-re on");
        break;
      case 2:
        strcpy(ParamRegEx, "-re off");
        break;
      case 3:
        strcpy(ParamRegEx, "-re auto");
        break;
      default:
        printf("Unexpected input\n");
        break;
    }
}

void cbPhonetic(FL_OBJECT *ob, long data)
{
    int         i;

    i = fl_get_choice(ob);

    switch(i)
    {
      case 1: 
        strcpy(ParamPhonetic, "-phon on");
        break;
      case 2:
        strcpy(ParamPhonetic, "-phon off");
        break;
      default:
        printf("Unexpected input\n");
        break;
    }
}


void cbConfigure(FL_OBJECT *ob, long data)
{
    FL_OBJECT *ret_obj;
    Window     win = fl_winget();

    cfNewFontSize = cfFontSize;
    strcpy(cfNewHeiseFile, cfHeiseFile);
    strcpy(cfNewRegPerlScript, cfRegPerlScript);

    begin_work(win, "Configure ...");
    if(NULL != fd_main)
        fl_deactivate_form(fd_main->main);

    fd_config = create_form_config();
    
    /* show the first form */
    fl_show_form(fd_config->config,FL_PLACE_CENTER,FL_TRANSIENT,"config");

reconfig:

    ret_obj = fl_do_forms();
    strcpy(cfNewHeiseFile, fl_get_input(fd_config->cfInputFile));
    strcpy(cfNewRegPerlScript, fl_get_input(fd_config->cfRegScript));
    if(fd_config->cfApplyButton == ret_obj)
    {
        /* check if config is valid */
        if(verify_new_conf()) goto reconfig;
        
        /* set new config */
        cfFontSize = cfNewFontSize;
        if(strcmp(cfHeiseFile, cfNewHeiseFile) != 0)
        {
            strcpy(cfHeiseFile, cfNewHeiseFile);
        }
        strcpy(cfRegPerlScript, cfNewRegPerlScript);
        status("Configuration applied.");
        cfCheck = cfNewCheck;
        cfDupes = cfNewDupes;


    }
    else
    {
        /* reset to old font size */
        if(NULL != fd_main)
        {
            fl_set_browser_fontsize(fd_main->List, cfFontSize);
            fl_set_browser_fontsize(fd_main->Output, cfFontSize);
        }
        status("Configuration resetted.");
    }
    
    
    fl_hide_form(fd_config->config);
    fl_free_form(fd_config->config);
    if(NULL != fd_main)
        fl_activate_form(fd_main->main);
    end_work(win);
}

void AddHeiseFile(FL_OBJECT *ob, long data)
{
    const char        *NewFilename;
    char               path[2048];
    char              *ptr;
    
    strcpy(path, cfHeiseFile);
    ptr = strrchr(path, '/');
    if(NULL != ptr)
    {
        *ptr = 0;
    }
    else
    {
        strcpy(path, ".");
    }

    status("Select file to add!");
    NewFilename = fl_show_fselector("Select CTI File",
            path, "*.[cC][tT][iI]", "");
    if(NewFilename != NULL && NewFilename[0] != 0)
    {
        status("Adding <%s> ...", NewFilename);
        add_update((char *)NewFilename);
        status("Added.");
    }
    else
    {
        status("Canceled");
    }
}

/*--------[ END OF FILE mask_cb.c ]------------------------------------------*/
